Commit 5061e773 authored by Ido Schimmel's avatar Ido Schimmel Committed by Jakub Kicinski
Browse files

selftests: mlxsw: Add scale test for tc-police



Query the maximum number of supported policers using devlink-resource
and test that this number can be reached by configuring tc filters with
police action. Test that an error is returned in case the maximum number
is exceeded.

Signed-off-by: default avatarIdo Schimmel <idosch@mellanox.com>
Reviewed-by: default avatarPetr Machata <petrm@mellanox.com>
Signed-off-by: default avatarJakub Kicinski <kuba@kernel.org>
parent cb12d176
Loading
Loading
Loading
Loading
+1 −1
Original line number Diff line number Diff line
@@ -28,7 +28,7 @@ cleanup()

trap cleanup EXIT

ALL_TESTS="router tc_flower mirror_gre"
ALL_TESTS="router tc_flower mirror_gre tc_police"
for current_test in ${TESTS:-$ALL_TESTS}; do
	source ${current_test}_scale.sh

+16 −0
Original line number Diff line number Diff line
# SPDX-License-Identifier: GPL-2.0
source ../tc_police_scale.sh

tc_police_get_target()
{
	local should_fail=$1; shift
	local target

	target=$(devlink_resource_size_get global_policers single_rate_policers)

	if ((! should_fail)); then
		echo $target
	else
		echo $((target + 1))
	fi
}
+1 −1
Original line number Diff line number Diff line
@@ -22,7 +22,7 @@ cleanup()
devlink_sp_read_kvd_defaults
trap cleanup EXIT

ALL_TESTS="router tc_flower mirror_gre"
ALL_TESTS="router tc_flower mirror_gre tc_police"
for current_test in ${TESTS:-$ALL_TESTS}; do
	source ${current_test}_scale.sh

+16 −0
Original line number Diff line number Diff line
# SPDX-License-Identifier: GPL-2.0
source ../tc_police_scale.sh

tc_police_get_target()
{
	local should_fail=$1; shift
	local target

	target=$(devlink_resource_size_get global_policers single_rate_policers)

	if ((! should_fail)); then
		echo $target
	else
		echo $((target + 1))
	fi
}
+92 −0
Original line number Diff line number Diff line
# SPDX-License-Identifier: GPL-2.0

TC_POLICE_NUM_NETIFS=2

tc_police_h1_create()
{
	simple_if_init $h1
}

tc_police_h1_destroy()
{
	simple_if_fini $h1
}

tc_police_switch_create()
{
	simple_if_init $swp1
	tc qdisc add dev $swp1 clsact
}

tc_police_switch_destroy()
{
	tc qdisc del dev $swp1 clsact
	simple_if_fini $swp1
}

tc_police_rules_create()
{
	local count=$1; shift
	local should_fail=$1; shift

	TC_POLICE_BATCH_FILE="$(mktemp)"

	for ((i = 0; i < count; ++i)); do
		cat >> $TC_POLICE_BATCH_FILE <<-EOF
			filter add dev $swp1 ingress \
				prot ip \
				flower skip_sw \
				action police rate 10mbit burst 100k \
				conform-exceed drop/ok
		EOF
	done

	tc -b $TC_POLICE_BATCH_FILE
	check_err_fail $should_fail $? "Rule insertion"
}

__tc_police_test()
{
	local count=$1; shift
	local should_fail=$1; shift

	tc_police_rules_create $count $should_fail

	offload_count=$(tc filter show dev $swp1 ingress | grep in_hw | wc -l)
	((offload_count == count))
	check_err_fail $should_fail $? "tc police offload count"
}

tc_police_test()
{
	local count=$1; shift
	local should_fail=$1; shift

	if ! tc_offload_check $TC_POLICE_NUM_NETIFS; then
		check_err 1 "Could not test offloaded functionality"
		return
	fi

	__tc_police_test $count $should_fail
}

tc_police_setup_prepare()
{
	h1=${NETIFS[p1]}
	swp1=${NETIFS[p2]}

	vrf_prepare

	tc_police_h1_create
	tc_police_switch_create
}

tc_police_cleanup()
{
	pre_cleanup

	tc_police_switch_destroy
	tc_police_h1_destroy

	vrf_cleanup
}